// $Id: GaudiTupleTool.cpp,v 1.6 2005/09/23 16:14:20 hmd Exp $
// ============================================================================
// Include files
// ============================================================================
// GaudiAlg
// ============================================================================
#include "GaudiAlg/GaudiTupleTool.h"
// ============================================================================

// ============================================================================
/*  @file GaudiTupleTool.cpp
 *
 *  Implementation file for class : GaudiTupleTool
 *
 *  @author Vanya BELYAEV Ivan.Belyaev@itep.ru 
 *  @author Chris Jones   Christopher.Rob.Jones@cern.ch
 *  @date   2004-06-28
 */
// ============================================================================

// ============================================================================
// Force creation of templated class
#include "GaudiAlg/GaudiTuples.icpp"
template class GaudiTuples<GaudiHistoTool> ;
// ============================================================================

// ============================================================================
// Standard constructor
// ============================================================================
GaudiTupleTool::GaudiTupleTool( const std::string& type   ,
                                const std::string& name   ,
                                const IInterface*  parent )
  : GaudiTuples<GaudiHistoTool> ( type , name , parent ) { }
// ============================================================================

// ============================================================================
// destructor
// ============================================================================
GaudiTupleTool::~GaudiTupleTool() { }
// ============================================================================

// ============================================================================
// standard initialization method
// ============================================================================
StatusCode GaudiTupleTool::initialize()
{
  // initialize the base class and return
  return GaudiTuples<GaudiHistoTool>::initialize();
}
// ============================================================================

// ============================================================================
// standard finalization method
// ============================================================================
StatusCode GaudiTupleTool::finalize()
{
  // finalize the base class and return
  return GaudiTuples<GaudiHistoTool>::finalize();
}
// ============================================================================

// ============================================================================
// The END
// ============================================================================



